<div class="settings-container">
  <div class="close" (click)="closeDialog()"></div>
  <img [src]="'assets/logo/Windflower_Logo.png'" class="icon" />
  <h1 mat-dialog-title class="settings-title">
    {{ "form.settings.title" | translate }}
  </h1>

  <div mat-dialog-content fxLayout="column" fxLayoutGap="20px">
    <div>
      <p class="settingsFormInfo">
        {{ "form.settings.additionalInformation" | translate }}
      </p>
    </div>

    <div mat-dialog-content class="settings-form">
      <form>
        <mat-label>{{ "form.label.firstName" | translate }}</mat-label>
        <!-- input field first name -->
        <mat-form-field>
          <input
            type="text"
            matInput
            [(ngModel)]="data.firstName"
            [ngModelOptions]="{standalone: true}"
            required
            #firstName="ngModel"
          />
        </mat-form-field>

        <!-- first name is required error -->
        <mat-error
          *ngIf="firstName.invalid && (firstName.dirty || firstName.touched)"
          class="errors"
        >
          <mat-icon>{{ 'warning' }}</mat-icon>
          <p>{{ "error.register.firstName" | translate }}</p>
        </mat-error>

        <p>{{ "form.label.lastName" | translate }}</p>
        <!-- input field last name -->
        <mat-form-field>
          <input
            type="text"
            matInput
            [(ngModel)]="data.lastName"
            [ngModelOptions]="{standalone: true}"
            required
            #lastName="ngModel"
          />
        </mat-form-field>

        <!-- lastname is required error -->
        <mat-error
          *ngIf="lastName.invalid && (lastName.dirty || lastName.touched)"
          class="errors"
        >
          <mat-icon>{{ 'warning' }}</mat-icon>
          <p>{{ "error.register.lastName" | translate }}</p>
        </mat-error>

        <p>{{ "form.label.mail" | translate }}</p>
        <!-- input field email -->
        <mat-form-field>
          <input
            type="mail"
            matInput
            [(ngModel)]="data.mail"
            [ngModelOptions]="{standalone: true}"
            required
            email
            #mail="ngModel"
          />
        </mat-form-field>

        <!-- email is required error -->
        <mat-error
          *ngIf="mail.invalid && (mail.dirty || mail.touched)"
          class="errors"
        >
          <mat-icon>{{ 'warning' }}</mat-icon>
          <p>{{ "error.register.mail" | translate }}</p>
        </mat-error>

        <!-- organization input field -->
        <div class="organization">
          <mat-form-field>
            <mat-label>{{ 'form.label.organization' | translate }}</mat-label>
            <mat-select
              #orga="ngModel"
              [ngModelOptions]="{ standalone: true }"
              [(ngModel)]="data.organizationId"
              required
              org
            >
              <mat-option
                *ngFor="let organization of organizations"
                [value]="organization.id"
              >
                <div class="icon-space">
                  <img
                    rel="icon"
                    type="image/x-icon"
                    [src]="organization.logo"
                  />
                  {{ organization.organizationName }}
                </div>
              </mat-option>
              <mat-option [value]="'0'">
                <button
                  class="no-text-transform-pill-button"
                  *ngIf="!newOrganizationSelected"
                  mat-stroked-button
                  (click)="newOrganization()"
                >
                  {{ 'newOrganization.create' | translate }}
                </button>
                <div *ngIf="newOrganizationSelected">{{ orgaName }}</div>
              </mat-option>
            </mat-select>
          </mat-form-field>
        </div>

        <!-- organization invalid -->
        <!-- <mat-error *ngIf="!orga.value" class="errors">
          <mat-icon>{{ 'warning' }}</mat-icon>
          <p>{{ 'error.register.organization' | translate }}</p>
        </mat-error> -->

        <!-- update personal data button -->
        <div
          mat-dialog-actions
          align="end"
          style="margin-bottom: 0px"
          class="update-button"
        >
          <button
            class="pill-button"
            mat-raised-button
            type="submit"
            color="primary"
            (click)="update(data)"
            [disabled]="firstName.invalid || lastName.invalid || mail.invalid || !orga.value"
          >
            {{ "form.label.update" | translate }}
          </button>
        </div>
        <br />

        <mat-form-field class="user-settings-full-width">
          <mat-label> {{ "form.label.oldPassword" | translate }} </mat-label>

          <!-- old password input field -->
          <input
            [(ngModel)]="data.oldPassword"
            [ngModelOptions]="{standalone: true}"
            class="mat-input"
            required
            [type]="hideOld ? 'password' : 'text'"
            type="text"
            matInput
            (input)="onOldPasswordChange('oldPassword')"
          />
          <mat-icon matSuffix class="icon" (click)="hideOld = !hideOld"
            >{{hideOld ? 'visibility_off' : 'visibility'}}
          </mat-icon>
        </mat-form-field>

        <!-- old password was wrong error -->
        <mat-error *ngIf="oldPasswordWasWrong" class="errors">
          <mat-icon>{{ 'warning' }}</mat-icon>

          <p>{{"error.register.wrongOldPassword" | translate}}</p>
        </mat-error>

        <!-- new password input field -->
        <mat-form-field class="user-settings-full-width">
          <mat-label> {{ "form.label.newPassword" | translate }} </mat-label>
          <input
            [(ngModel)]="data.newPassword"
            [ngModelOptions]="{standalone: true}"
            class="mat-input"
            required
            [type]="hideNew ? 'password' : 'text'"
            type="text"
            matInput
            (input)="onOldPasswordChange('newPassword')"
          />
          <mat-icon matSuffix class="icon" (click)="hideNew = !hideNew"
            >{{hideNew ? 'visibility_off' : 'visibility'}}
          </mat-icon>
        </mat-form-field>

        <!-- password contains not allowed letters error message -->
        <mat-error *ngIf="isInvalid(data.newPassword)" class="errors">
          <mat-icon>{{ 'warning' }}</mat-icon>

          <p>{{"error.register.invalid" | translate}}</p>
        </mat-error>

        <!-- Password to short error message -->
        <mat-error *ngIf="tooShort(data.newPassword)" class="errors">
          <mat-icon>{{ 'warning' }}</mat-icon>

          <p>{{"error.register.short" | translate}}</p>
        </mat-error>

        <!-- New Password is the same as old one -->
        <mat-error *ngIf="newPasswordIsSameAsOldPassword" class="errors">
          <mat-icon>{{ 'warning' }}</mat-icon>

          <p>{{"error.register.newPasswordIsSameAsOldPassword" | translate}}</p>
        </mat-error>

        <!-- change password button -->
        <div mat-dialog-actions align="end">
          <button
            mat-raised-button
            type="submit"
            color="primary"
            (click)="editPassword(data)"
            [disabled]="isInvalid(data.newPassword) || tooShort(data.newPassword) || !(data.newPassword)"
          >
            {{ "form.label.changePassword" | translate }}
          </button>
        </div>
      </form>
    </div>
  </div>
</div>
